// *** List3-4 ***
struct SimpleDate {
    var year, month, day: Int
    init() {
       year = 2095; month = 10; day = 31
    } // self.year = 2095 のように書くこともできる
}

// *** List3-5 ***
struct Time {
    let in24h: Bool                 // 初期値はない
    var hour = 0, min = 0
    init(hour:Int, min:Int) {       // hour, min は外部引数名になる
        in24h = false               // 定数を初期設定できる
        self.hour = hour            // self.プロパティで引数名と区別
        self.min = min
    }
    init(hourIn24 h:Int) {
        in24h = true                // 定数を初期設定できる
        hour = h
    }
    init(_ hour:Int) {              // 外部引数名を使わない
        self.init(hourIn24: hour)   // 上のイニシャライザを使う
        // in24h = false  これはエラーになる
    }
}

// *** List3-6 ***
struct DateWithTime {
    var date = SimpleDate()
    var time = Time(hour:0, min:15)
}

var u = DateWithTime()
print(u.date.year)    // 2095が出力される
print(u.time.min)     // 15が出力される
