// List5-11の定義
protocol EqVector: Equatable {          // 比較が可能な Equatableを継承
    associatedtype Element: Equatable   // 付属型に適合するプロトコルを指定
    var x : Element { get set }
    var y : Element { get set }
}

// List5-13の定義

struct VectorInt : EqVector, CustomStringConvertible {
    var x, y: Int
    var description: String { return "[\(x), \(y)]" }
    /* Equatable に適合するために必要 */
    static func ==(lhs: VectorInt, rhs: VectorInt) -> Bool {
        return lhs.x == rhs.x && lhs.y == rhs.y
    }
}

let mx: VectorInt.Element = 10  // VectorInt.Element は Int型
let a = VectorInt(x:mx, y:7)
print(a)
var b = VectorInt(x:5, y:7)
print(a != b)
b.x *= 2
print(a == b)
