// EqVectorの定義を、SimpleVectorを継承する形に変更したバージョン

protocol SimpleVector {         // ２次元ベクトル型
    associatedtype Element     	// 付属型の宣言
    var x : Element { get set }
    var y : Element { get set }
}

protocol EqVector: SimpleVector, Equatable
    where Self.Element : Equatable { }

// ここから下は List5-13 と同じ

struct VectorInt : EqVector, CustomStringConvertible {
    var x, y: Int
    var description: String { return "[\(x), \(y)]" }
    /* Equatable に適合するために必要 */
    static func ==(lhs: VectorInt, rhs: VectorInt) -> Bool {
        return lhs.x == rhs.x && lhs.y == rhs.y
    }
}

let mx: VectorInt.Element = 10  // VectorInt.Element は Int型
let a = VectorInt(x:mx, y:7)
print(a)
var b = VectorInt(x:5, y:7)
print(a != b)
b.x *= 2
print(a == b)
