struct Time : Comparable, CustomStringConvertible {
    let hour, min: Int      // 定数で時刻を保持。全項目イニシャライザを使う
    static func ==(lhs: Time, rhs: Time) -> Bool {
        return lhs.hour == rhs.hour && lhs.min == rhs.min
    }
    static func <(lhs: Time, rhs: Time) -> Bool {
        return lhs.hour < rhs.hour
            || (lhs.hour == rhs.hour && lhs.min < rhs.min)
    }
    var description : String { // 表示のため
        let h = hour < 10 ? " \(hour)":"\(hour)"
        let m = min < 10 ? "0\(min)":"\(min)"
        return h + ":" + m
    }
}

let t1 = Time(hour:9, min:0)
let t2 = Time(hour:18, min:30)
let t3 = Time(hour:12, min:15)
print( t1 != t2 )	// true
print( t1 > t3 )	// false
print( [t1, t2, t3].sorted() )	// [ 9:00, 12:15, 18:30]
