struct Time : CustomStringConvertible {
    let hour, min : Int    // 定数で時刻を保持。全項目イニシャライザを使う
    func add(min:Int) -> Time {       // 分を加算する
        var m = self.min + min
        var h = self.hour
        if m >= 60 {
            h = (h + m / 60) % 24
            m %= 60
        }
        return Time(hour:h, min:m)    // 新しいインスタンスを返す
    }
    var description : String {
        let h = hour < 10 ? " \(hour)":"\(hour)"
        let m = min < 10 ? "0\(min)":"\(min)"
        return h + ":" + m
    }
}

let tm = Time(hour:19, min:40)  // イニシャライザ
print(tm)
let t2 = tm.add(min:20)         // 20分進める
print("時刻は\(t2)です。")
