protocol Human {
    var name: String? { get }            // 名前
    func sayHello(to: Human)             // 人に挨拶する
}

struct Mob : Human {
    let name: String? = nil               // プロパティを定数で実装
    init() { }                            // イニシャライザは何もしない
    func sayHello(to:Human) { print("どうも") }
    func cheer() { print("頑張れ") }      // Humanには存在しないメソッド
}

var a = Mob()
var b = Mob()
a.sayHello(to: b)
b.sayHello(to: a)

func printNames(list:[Human]) {
    for p in list {
        print((p.name ?? "名無し") + "さん")
        // p.cheer()                   // この呼び出しはできない
    }
}
printNames(list: [a, b])
