protocol Human {
    var name: String? { get }            // 名前
    func sayHello(to: Human)             // 人に挨拶する
}

struct Mob : Human {
    let name: String? = nil               // プロパティを定数で実装
    init() { }                            // イニシャライザは何もしない
    func sayHello(to:Human) { print("どうも") }
    func cheer() { print("頑張れ") }      // Humanには存在しないメソッド
}

protocol Staff : Human {             // プロトコルを継承する
    var title: String { get set }    // 肩書き：読み書き可能なプロパティ
}

struct Employee : Staff {            // プロトコルStaffを採用
    let name: String?
    var title: String = ""
    func sayHello(to p: Human) {
        var s = "ご苦労様です"
        if let who = p.name { s += "、" + who + "さん" }
        print(s)
    }
}

protocol Fullname {
    var lastname: String { get }     // 苗字
    var firstname: String { get }    // 名前
}
struct Student: Human, Fullname {
    let lastname, firstname: String
    var name: String? {                     // 計算型プロパティで実装
        return lastname + firstname
    }
    func sayHello(to p: Human) {
        var s = "こんにちは"
        if let who = p.name { s += "、" + who + "さん" }
        print(s)
    }
}

var a = Mob()
var b = Employee(name:"安岡", title:"ボディーガード")
var c = Student(lastname:"夏川", firstname:"真那")
a.sayHello(to: b)
b.sayHello(to: c)
c.sayHello(to: a)
