enum Direction : Int {
    case up = 0, right, down, left        // 時計回りに並べ直す
    func clockwise() -> Direction {
        let t = (self.rawValue + 1) % 4   // selfはインスタンス自体
        return Direction(rawValue:t)!     // nilにはならない
    }
}

let d = Direction.up
print(d.clockwise() == .down)                 // false
print(d.clockwise().clockwise() == .down)     // true
