enum Direction : Int {
    case up = 0, right, down, left
    func clockwise() -> Direction {
        let t = (self.rawValue + 1) % 4
        return Direction(rawValue:t)!
    }
    var horizontal: Bool {
        switch self {
        case .right, .left: return true
        default: return false
        }
    }
    mutating func turnBack() {
        self = Direction(rawValue:((self.rawValue + 2) % 4))!
    }
}

var d = Direction.left
print(d.rawValue)
d.turnBack()
print(d.rawValue)
print("horizontal: \(d.horizontal)")
