enum Ticket {
    case 切符(Int, Bool, 回数券:Bool) // 普通券：価格、小人、回数券かどうか
    case カード(Int, Bool)            // プリペイドカード：残高、小人
    case 敬老パス                     // 敬老パス
}

var list:[Ticket] = [
    .切符(250, false, 回数券:false),
    .切符(220, false, 回数券:true),
    .敬老パス,
    .カード(3300, false),
    .カード(50, true)
]

for t in list {
switch t {
case let .切符(fare, flag, _):
    print("普通券: \(fare) " + (flag ? "小人" : "大人"))
case .敬老パス:
    print("敬老パス")
case .カード(let r, true) where r < 110:   // 小人の最低運賃
    print("カード: 残額不足")
case .カード(let r, false) where r < 230:  // 大人の最低運賃
    print("カード: 残額不足")
case .カード:
    print("カード")
}
}

print("------------")

for t in list {
switch t {
case .切符(let fare, let flag, 回数券: let sers):
    var app = flag ? "小人" : "大人"
    if sers { app += ", 回数券" }
    print("普通券: \(fare) " + app)
case .敬老パス:
    print("敬老パス")
case let .カード(r, child) where child && r < 110:   // 小人の最低運賃
    print("カード: 残額不足(小人)")
case .カード(let r, _) where r < 230:  // 大人の最低運賃
    print("カード: 残額不足(大人)")
case .カード:
    print("カード")
}
}
