enum Ticket {
    case 切符(Int, Bool, 回数券:Bool) // 普通券：価格、小人、回数券かどうか
    case カード(Int, Bool)            // プリペイドカード：残高、小人
    case 敬老パス                     // 敬老パス
    mutating func pay(_ u:Int) -> Bool {    // 改札を通過できるか
        switch self {
        case .切符(let fare, _, _):
            return u <= fare                // 購入金額と比較する
        case .カード(let point, let flag):
            if point < u { return false }   // 支払いできない
            self = .カード(point - u, flag) // 情報を書き換える
        default: break
        }
        return true
    }
}

let passes:[Ticket] = [
    .カード(300, true),
    .切符(120, true, 回数券:true),
    .敬老パス,
    .カード(3300, false)
]

for t in passes {
var tt = t
if tt.pay(260) {
    if case .カード(let p, _) = tt {
        print("OK, カード残額=\(p)")
    }else {
        print("OK")
    }
} else { print("OUT") }

}

print("------")
var mycard:Ticket = .カード(300, false)	// 残高300円、大人
if mycard.pay(260) { print("OK") }    	// 残高40円になる
if mycard.pay(220) { print("OK") }    	// 残高不足。印字しない
