import Foundation    // Linux ではこれが必要

enum Suit : String { // スートを列挙型で定義
    case spade, club, diamond, heart       // 名前の文字列が実体値になる
    static func ~= (m: Suit, str: String) -> Bool {
        let low = str.lowercased()         // 小文字に直す
        return m.rawValue.hasPrefix(low)   // 先頭部分に一致？
    }
}

print( Suit.spade ~= "spade" )
print( Suit.heart ~= "H" )
print( Suit.heart ~= "diamond" )
let c = "dia"
print( Suit.diamond ~= c )

// print( "Test", (.diamond, _) ~= (c, 10) )      タプルだとダメ
// if case Suit.diamond = c { print("test OK") }  型名から書くとダメ
if case .diamond = c { print("test OK") }

let d = Suit.diamond
if case d = c { print(c) }
if case (_, d) = (10, c) { print(c) }

let trump = ("Spade", 1)
switch trump {
case (.diamond, _): print("ダイア")
case (.spade, let x): print("スペード \(x)")
default: break
}
