class Recipe {
    let amount = [ 6.6, 8.9, 7.5, 9.1 ]
    subscript (idx:Int) -> Double {            // 読み取り専用
        return idx < amount.count ? amount[idx] : 0.0
    }
}

class Arrange : Recipe {
    var multiple = 1.0
    init(_ mul: Double) {  // 新しいイニシャライザなので override は不要
        super.init()
        multiple = mul                          // 倍数を設定
    }
    override subscript (idx:Int) -> Double {    // override が必要
        return super[idx] * multiple            // super[ ] で参照できる
    }
}

var a = Arrange(2.0)
for i in 0 ..< 4 {
    print(a[i])
}
