class Avatar {
    class func say() { print("Avatar") }           // クラスメソッド
    required init() { }                            // 必須イニシャライザ
}
class Player : Avatar {
    override class func say() { print("Player") }  // クラスメソッド
    let name:String
    init(name:String) {
        self.name = name
        super.init()
    }
    required convenience init() { self.init(name:"(none)") }
}

var meta: Avatar.Type = Player.self  // メタタイプの変数を定義
meta.say()                           // "Player" を表示
let p:Avatar = meta.init()           // インスタンスを作成できる
if type(of: p) === Player.self {     // === 演算子で比較できる
    print( (p as! Player).name )     // "(none)" を表示
}
let q = Avatar()
meta = type(of: q)        // インスタンスからクラスオブジェクトを得る
meta.say()                // "Avatar" を表示
