class A : CustomStringConvertible {
    static var className : String { return "A" }
    static var total = 0
    class var level : Int { return 1 }
    static func point() -> Int { return 1000 }
    class func say() -> String {
        return ["1st", "2nd", "3rd"][self.level - 1]
    }
    init() { A.total += 1 }
    var description: String {
        return "\(A.total): \(A.className), "
            + "Level=\(A.level), \(A.point())pt, \(A.say())"
    }
}

class B : A {
    // override static var className : String { return "B" }
    // 定義不可. error: cannot override static var
    // static var total = 0
    // 定義不可. error: cannot override with a stored property 'total'
    override class var level : Int { return 2 }
    // override static func point() -> Int { return 2000 }
    // 定義不可. error: cannot override static method
    override class func say() -> String {
        return ["初級", "中級", "上級"][self.level - 1]
    }
    override init() { super.init(); B.total += 1 }
    override var description: String {
        return "\(B.total): \(B.className), "
            + "Level=\(B.level), \(B.point())pt, \(B.say())"
    }
}

let a = A()
print(a)
let b = B()
print(b)
