class CalendarDate : DateInfo {
    static let namesOfDays = [
        "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" ]
    var dweek = String()                           // ここに注意！
    override init(_ y:Int, _ m:Int, _ d:Int) {     // overrideが必要
        super.init(y, m, d)
        dweek = CalendarDate.namesOfDays[dow]      // ここに注意！
    }
    static var defaultYear = 2010         // 年の既定値
    convenience init(_ m: Int, _ d:Int) { // 簡易イニシャライザの定義
        self.init(CalendarDate.defaultYear, m, d)
    }
    override var day:Int {  // プロパティの上書きなのでoverrideが必要
        didSet {
            dow = dayOfWeek(year, month, day)
            dweek = CalendarDate.namesOfDays[dow]  // 曜日の計算をやり直す
        }
    }
    override var description: String {      // 計算型プロパティの上書き
        return "\(year)/" + super.description + " (\(dweek))"
    }
}
