class Student : CustomStringConvertible {
    let name: String                       // 名前
    var club: Club?                        // 所属クラブ
    init(name:String) { self.name = name }
    var description: String {
        var s = "\(name)"
        if let mem = club { s += ", \(mem.name)" }
        return s
    }
    deinit {                               // デイニシャライザ
        print("\(name): deinit")
    }
}

class Club {
    let name: String                       // クラブ名
    var members = [Student]()              // 所属学生のリスト
    init(name:String) { self.name = name }
    func add(_ p:Student) {                // 学生を追加する
        members.append(p)
        p.club = self                      // 学生の所属も書き換える
    }
    deinit {                               // デイニシャライザ
        print("Club \(name): deinit")
    }
}

do {
    let tinyClub: Club = Club(name:"昼寝同好会")
    let yuji:Student = Student(name:"悠二")
    /* tinyClub.add(yuji) */    // 実行すると、インスタンスが解放されない
    print("\(tinyClub.name): \(tinyClub.members.count)人")
    print(yuji)
}
print("終わり")
