class Student : CustomStringConvertible {
    let name: String                       // 名前
    weak var club: Club?                   // 所属クラブ ← weakを追加
    init(name:String) { self.name = name }
    var description: String {
        var s = "\(name)"
        if let mem = club { s += ", \(mem.name)" }
        return s
    }
    deinit {                               // デイニシャライザ
        print("\(name): deinit")
    }
}

class Club {
    let name: String                       // クラブ名
    var members = [Student]()              // 所属学生のリスト
    init(name:String) { self.name = name }
    func add(_ p:Student) {                // 学生を追加する
        members.append(p)
        p.club = self                      // 学生の所属も書き換える
    }
    deinit {                               // デイニシャライザ
        print("Club \(name): deinit")
    }
}

var yuji:Student = Student(name:"悠二")
do {
    let tinyClub: Club = Club(name:"昼寝同好会")
    tinyClub.add(yuji)
    tinyClub.add(Student(name:"一美"))   // もう一人追加
    print("\(tinyClub.members.count)人")
}
print(yuji)
print("終わり")
