class Student : CustomStringConvertible {
    let name: String                       // 名前
    var club: Club?                        // 所属クラブ
    init(name:String) { self.name = name }
    var description: String {
        var s = "\(name)"
        if let mem = club { s += ", \(mem.name)" }
        return s
    }
    deinit {                               // デイニシャライザ
        print("\(name): deinit")
    }
}

class Club {
    let name: String                       // クラブ名
    var members = [Student]()              // 所属学生のリスト
    init(name:String) { self.name = name }
    func add(_ p:Student) {                // 学生を追加する
        members.append(p)
        p.club = self                      // 学生の所属も書き換える
    }
    deinit {                               // デイニシャライザ
        print("Club \(name): deinit")
    }
}

weak var who: Student? = nil
do {
    let kaz:Student = Student(name:"一美")
    who = kaz           // 弱い参照の変数に値を代入
    print(who!)         // "一美" と表示
}                       // do文が終わり、"一美: deinit" と表示
print(who ?? "nil")     // "nil" と表示

print("------")

weak var yukari:Student? = Student(name:"ゆかり")
print("終わり")
