class Student {
    let name: String                 // 名前
    weak var club: Club?             // 弱い参照
    init(name:String) { self.name = name }
}

class Teacher {
    let name: String                 // 名前
    var subject: String? = nil       // 担当教科
    init(name:String) { self.name = name }
}

class Club {
    let name: String                 // 名前
    weak var teacher: Teacher?       // 弱い参照
    var budget = 0                   // 予算
    var members = [Student]()
    init(name:String) { self.name = name }
    func add(_ p:Student) {
        members.append(p)
        p.club = self
    }
    func isOfficial() -> Bool {          // 公認クラブか？
        return members.count >= 5 && teacher != nil
    }
}

var who:Student? = Student(name:"井上")
var club = Club(name:"隣人部")
club.add(who!)
var t = Teacher(name:"高山")
t.subject = "精神発達理論"
club.teacher = t

if let b = who?.club?.budget {
    print("予算: \(b)")
}

if let recognized = who?.club?.isOfficial() {
    print("クラブ: " + (recognized ? "公認" : "非公認"))
}else {
    print("クラブ自体がない")
}

if let subj = who?.club?.teacher?.subject {
    print("担当教科: \(subj)")
}

// p.241
let sena = Student(name:"星奈")
if who?.club?.add(sena) != nil {
    print(sena.name, sena.club!.name)
}

if (who?.club?.budget += 5000) != nil {
    print("予算: \(who!.club!.budget)")
}
