class Student {
    let name: String                 // 名前
    weak var club: Club?             // 弱い参照
    init(name:String) { self.name = name }
}

class Teacher {
    let name: String                 // 名前
    var subject: String? = nil       // 担当教科
    init(name:String) { self.name = name }
}

class Club {
    let name: String                 // 名前
    weak var teacher: Teacher?       // 弱い参照
    var budget = 0                   // 予算
    var members = [Student]()
    init(name:String) { self.name = name }
    func add(_ p:Student) {
        members.append(p)
        p.club = self
    }
    func isOfficial() -> Bool {          // 公認クラブか？
        return members.count >= 5 && teacher != nil
    }
}

var s = Student(name:"井上")
var club = Club(name:"隣人部")
club.add(s)
var t = Teacher(name:"高山")
t.subject = "精神発達理論"
club.teacher = t

// オプショナルチェーン
if let name = s.club?.teacher?.name {
    print(name)
}

// キーパス
let teacherNamePath = \Student.club?.teacher?.name

if let name = s[keyPath: teacherNamePath] {
    print(name)
}

print(type(of: teacherNamePath))
