struct MonthAndDay : Hashable, CustomStringConvertible {
    var month, day: Int
    init(_ m:Int, _ d:Int) { month = m; day = d }
    var hashValue: Int { return month * 32 + day }     	// ハッシュ値
    static func ==(lhs:MonthAndDay, rhs:MonthAndDay) -> Bool {
        return lhs.month == rhs.month && lhs.day == rhs.day
    }
    var description: String { return "(\(month), \(day))" }
}

var ds:Set<MonthAndDay> = [ MonthAndDay(6, 18), MonthAndDay(1, 3),
    MonthAndDay(4, 16), MonthAndDay(1, 3), MonthAndDay(6, 18) ]
print(ds)   // [(6, 18), (4, 16), (1, 3)] が表示される
