struct RoomOption : OptionSet {
    typealias RawValue = Int    // 実体型として Int を指定
    let rawValue: RawValue
    static let none = RoomOption(rawValue: 0x00)      // 何もなし
    static let internet = RoomOption(rawValue: 0x01)  // インターネットあり
    static let breakfast = RoomOption(rawValue: 0x02) // 朝食付き
    static let fullbath = RoomOption(rawValue: 0x04)  // 浴槽付き
    static let all = RoomOption(rawValue: 0x07)       // すべてあり
}

var room: RoomOption = [ .internet, .fullbath ]
print( room.rawValue )	// 5 が表示される
if !room.contains(.breakfast) { room.insert(.breakfast) }
print( room.rawValue )	// 7 が表示される
