protocol Dateable {
    var year: Int { get }
    var month: Int { get }
    var day: Int { get }
}

// ツェラーの公式。既出。
func Zeller(_ y:Int, _ m:Int, _ d:Int) -> Int {
    var y = y, m = m       // 少々トリッキー。変数yは仮引数のyとは違う
    if m < 3 {             // 1,2月だったら
        m += 12; y -= 1    // 前年の13月、14月として計算する
    }
    let leap = y + y / 4 - y / 100 + y / 400
    return (leap + (13 * m + 8) / 5 + d) % 7
}

extension Dateable {
    var dayOfWeek: Int {
        return Zeller(year, month, day)
    }
}

struct SimpleDate : Dateable { // プロトコルを採用した構造体
    var year, month, day: Int
}

let d1 = SimpleDate(year:1992, month:7, day:19)
print(d1)
print(d1.dayOfWeek)

let d2: Dateable = SimpleDate(year:1994, month:2, day:1)
print(d2)
print(d2.dayOfWeek)
let d3 = SimpleDate(year:1991, month:12, day:14)
print(d3)
print(d3.dayOfWeek)
