// 注意: Linuxでは動作しません。
// Swift 4.0 では Linuxで PropertyListEncoder, PropertyListDecoder
// が利用できません。

import Foundation

struct People : Codable, CustomStringConvertible {
    let name: String 
    var age: Int 
    var description: String { return name + " (\(age))" }
} 

let group = [ People(name:"小野ミサ", age:17),
              People(name:"烏丸ミユ", age:21) ]

let path = URL(fileURLWithPath:"./data_archive.plist")
var encoder = PropertyListEncoder() // エンコーダを得る
// encoder.outputFormat = .xml
var decoder = PropertyListDecoder() // デコーダを得る
do {
    let d = try encoder.encode(group)     // groupをエンコード
    try d.write(to:path)                 // データをファイルに保存
    // 上で作ったデータを読み込んで復元する
    let dat = try Data(contentsOf:path)
    let gs = try decoder.decode([People].self, from: dat)
    print(gs)  // 復元したデータを表示
} catch { print(error) }
