import Foundation

func copyFile(path:String, to dest:String) -> Bool {
    let fpin = fopen(path, "r")              // 入力ファイルをオープン
    guard fpin != nil else { return false }  // オープンに失敗
    let fpout = fopen(dest, "w")    // 出力ファイルをオープン
    guard fpout != nil else {       // 出力ファイルのオープンに失敗
        fclose(fpin)                // ← (1) 入力ファイルをクローズ
        return false
    }
    while true {                    // １文字ずつコピー
        let ch = fgetc(fpin)
        if ch < 0 { break }         // ファイルの終わり（EOF）
        fputc(ch, fpout)
    }
    fclose(fpin)    // ← (2) 入力ファイルをクローズ
    fclose(fpout)   // ← (2) 出力ファイルをクローズ
    return true
}

if copyFile(path:"text.txt", to:"copy.txt") {
    print("success")
}else {
    print("failure")
}
