class Gear {
    private enum NRG { case low, high }
    fileprivate var name: String          // ★可視性をfileprivateに
    init(name n: String) { name = n }
    func sing(_ s: String) {
        print(arm(.high) + " " + s)       // 拡張定義内のメソッドにアクセス可能
    }
}

extension Gear {
    private func arm(_ s: NRG) -> String {  // privateなメソッド
        return name + ((s == .high) ? " XD" : "")
    }                                     // nameにもNRG型にもアクセス可能
}

class SubGear : Gear {
    override func sing(_ s: String) {
        print(name + "\u{266A}" + s)      // ★プロパティnameにアクセス可能
    }
}

let a = Gear(name: "Gungnir")
a.sing("Wing")
let b = SubGear(name: "Ichaival")
b.sing("Break")
