class USBCamera {
    fileprivate var aperture = 2.0    // 絞りとシャッタースピードは個別に設定
    fileprivate var shutterSpeed = 1.0 / 1000.0
    fileprivate func take() {      // 写真を撮る
        print("take a picture")
    }
}

class WebCamera : USBCamera {
    override var aperture: Double {
        didSet { // 絞りに応じてシャッタースピードを設定
            shutterSpeed = ss(super.aperture)
        }
    }
    override internal fileprivate(set) var shutterSpeed: Double {
        get { return super.shutterSpeed }
        set { super.shutterSpeed = newValue }
    }
    internal override func take() { super.take() }
    private func ss(_ f:Double) -> Double {
        return (f * f) / 4000.0             // シャッタースピードを計算
    } // 明るい（fが小さい）ほどシャッタースピード（露光時間）を短くする
}
