import Foundation

struct People : Codable, CustomStringConvertible {
    let name: String 
    var age: Int 
    var description: String { return name + " (\(age))" }
} 

let group = [ People(name:"小野ミサ", age:17),
              People(name:"烏丸ミユ", age:21) ]

let path1 = URL(fileURLWithPath:"./data_group.json")
let path2 = URL(fileURLWithPath:"./data_person.json")
var encoder = JSONEncoder() // エンコーダを得る
var decoder = JSONDecoder() // デコーダを得る
do {
    let d = try encoder.encode(group)     // groupをエンコード
    try d.write(to:path1)                 // データをファイルに保存
    let load = try Data(contentsOf:path2) // データを読み込む
    let who = try decoder.decode(People.self, from: load)
    print(who)  // 読み込んだデータから Person型のインスタンスを生成
    // 上で作ったデータを読み込んで復元する
    let gdat = try Data(contentsOf:path1)
    let gs = try decoder.decode([People].self, from: gdat)
    print(gs)  // 復元したデータを表示
} catch { print(error) }
