class NumberMatrix {
    let data: [[Int]]                               // データ
    let maxval: Int                                 // データの最大値
    var format = { (n:Int) -> String in " \(n)" }   // 整形用クロージャ
    init(data:[[Int]]) {
        self.data = data
        maxval = data.map{ $0.max()! }.max()!
    } // 各行の最大値を求め、それらの最大値を再び求める
    func output() { // 行列の出力
        for lin in data {
            for col in lin { print(format(col), terminator:"") }
            print()
        }
    }
    func makePercent() {  // 最大値を100としたパーセント表示にする
        format = { [ maxval ] (n:Int) -> String in
            let m = Int(Double(n * 100) / Double(maxval) + 0.5)
            return String("   \(m)".suffix(4))   // 空白を含め、４桁表示する
        }
    }
    deinit { print("deinit Matrix") }
}

do {
    let mat = NumberMatrix(data: [ [ 200, 10, 0 ], [ 1, 990, 1280 ] ])
    mat.output()
}

print("------")
do {
    let mat = NumberMatrix(data: [ [ 200, 10, 0 ], [ 1, 990, 1280 ] ])
    mat.makePercent()
    mat.output()
}

print("------")
do {
    let mat = NumberMatrix(data: [ [ 20090, 10, 3090 ], [ 1, 990, 1280 ] ])
    let mx = mat.maxval
    var width = 2, d = 10, sp = " "
    while d < mx { width += 1; d *= 10; sp += " " }
    mat.format = { (n:Int) -> String in
        String((sp + "\(n)").suffix(width))
    }
    mat.output()
}
