import Foundation

class FileAttribute {
    let filename: String
    lazy var size:Int = self.getFileSize()  // 遅延評価で値を決定
    init(file: String) {
        filename = file
    }
    func getFileSize() -> Int {
        var buffer = stat()         // 構造体の初期化
        stat(filename, &buffer)     // statを呼び出す
        print("[getFileSize]")      // 動作確認のための印字
        return Int(buffer.st_size)  // 得られた値をInt型に変換
    }
}

let d = FileAttribute(file:"text.txt")
print(d.filename)
print(d.size)
print(d.size)
