import Foundation

func separate(_ list:[String], by filter:(String)->Bool)
         -> ([String],[String]) {  // 配列のタプルを返す
    var sel = [String]()           // 条件に合致する要素を格納する配列
    var des = [String]()           // 条件に合致しない要素を格納する配列
    for s in list {                // 配列の要素を１つずつ取り出す
        if filter(s) {             // クロージャを使って条件判定
            sel.append(s)
        }else{
            des.append(s)
        }
    }
    return (sel, des)              // タプルを作って返す
}

let list = ["fig.pdf", "filelist1.swift", "OLD", "sample.swift"]

let t = separate(list, by:{
    for ch in $0 {
        if case "A" ... "Z" = ch { return true }
    }
    return false
})
print(t)

print("------")
// ファイル名を実際に読み込んで実行してみよう。

func filenames(path: String) -> [String]? {
    let fm = FileManager.default
    return try? fm.contentsOfDirectory(atPath:path)
}

if let flist = filenames(path:".") { // カレントディレクトリのファイル
    // print(flist)
    let t = separate(flist, by:{ $0.hasPrefix("List") } )
    print(t.0)   // Listから始まるファイル名のみ表示
}
