enum XError : Error {
    case Zero
    case Byte
}

func apply(to arg: inout [Int], _ map:(Int) throws -> Int) rethrows {
    for i in 0 ..< arg.count {
        arg[i] = try map(arg[i])
    }
}

var list = [ 1, 2, 3, 4, 5 ]
let bell = { (a:Int) throws -> Int in       // エラーのあるクロージャ
    let q = a * a
    if q >= 256 { throw XError.Byte }       // 8ビットを超えるとエラー
    return q
}
if let _ = try? apply(to:&list, bell) {     // エラーがなければnil以外
    print( list )
}else {
    print("エラー発生 (1)")
}
// もう一度同じ呼び出しを行うとエラーが発生する。
if let _ = try? apply(to:&list, bell) {
    print( list )     // [1, 4, 9, 16, 25] を表示
}else {
    print("エラー発生 (2)")
}

print("------")

list = [ 1, 2, 3, 4, 5 ]

// エラーを発生させないクロージャ
let aiz = { (a:Int) -> Int in
    return (a * a) & 0xff
}
apply(to:&list, aiz)  // 呼び出しに try は必要ない
print( list )
apply(to:&list, aiz)
print( list )
