import Foundation

func separate(_ list:[String], by filter:(String)->Bool)
         -> ([String],[String]) {  // 配列のタプルを返す
    var sel = [String]()           // 条件に合致する要素を格納する配列
    var des = [String]()           // 条件に合致しない要素を格納する配列
    for s in list {                // 配列の要素を１つずつ取り出す
        if filter(s) {             // クロージャを使って条件判定
            sel.append(s)
        }else{
            des.append(s)
        }
    }
    return (sel, des)              // タプルを作って返す
}

let list = ["fig.pdf", "filelist1.swift", "OLD", "sample.swift"]

// 接尾クロージャ
let t = separate(list) {
    for ch in $0 {
        if case "A" ... "Z" = ch { return true }
    }
    return false
}
print(t)
