enum XError : Error {
    case Zero
    case Byte
}

let avg = { (a:[Double]) throws -> Double in
    guard a.count > 0 else { throw XError.Zero } // エラーを投げる
    var sum = 0.0
    for d in a { sum += d }
    return sum / Double(a.count)
}

if let d = try? avg([4.0, 2.2]) { print(d) }

var clo : ([Double]) throws -> Double = avg      // 代入可能
clo = { (a:[Double]) -> Double in return 0.0 }   // 代入可能

print( try! clo([0.5, 2.8, 4.1]) )   // try または try! が必要
