protocol SimpleVector {               // ２次元ベクトル型
    associatedtype Element            // 付属型の宣言
    var x : Element { get set }
    var y : Element { get set }
}

struct Vector<T> : SimpleVector {
    typealias Element = T   // 付属型をパラメータで指定された型で定義
    var x, y: Element       // 格納型プロパティ
}

let a: Vector<Int> = Vector<Int>(x:12, y:3)
print(a.x, a.y)
let b = Vector<[String]>(x:[], y:["黒", "noir", "schwarz"]) // 使用可能
print(b)
let c = Vector<Vector<Int>>(x:a, y:Vector<Int>(x:6, y:8))
print(c.y.x)

print("------")
let p = Vector(x:10, y:2.0)
print(p.y)
print(type(of:p))
