main : do {
    guard let words = WordReader(open:"text.txt") else {
        print("ファイルがオープンできません")
        break main
    }
    guard let w = words.getWord() else { break main } // ファイルが空
    let seq = sequence(first: w, next: { _ in words.getWord() })
    let dic = seq.map{ $0.lowercased() }         // 小文字に変換する
                 .reduce(into: [:]) {
        (d: inout [String:Int], key: String) in
        d[key, default:0] += 1                   // 文字列の出現頻度を調べる
    }
    for elm in dic.sorted(by:{ $0.value > $1.value }).prefix(10) {
        print("\"\(elm.0)\"", elm.1)
    } // 出現頻度の多いものから10個を表示
}
