import Foundation

class WordReader {
    var fptr: UnsafeMutablePointer<FILE>? = nil
    init?(open:String) {                // 失敗のあるイニシャライザ
        fptr = fopen(open, "r")         // C言語の FILE* 型のオプショナル
        if fptr == nil { return nil }   // オープンに失敗
    }
    deinit {                    // デイニシャライザ
//      print("[[deinit]]")     // 動作確認のために文字列を表示する
        self.close()
    }
    func close() {
        if let fp = fptr {      // オープンされていればクローズする
            fclose(fp)
            fptr = nil
        }
    }
    func getWord() -> String? {        // オプショナル型を返す
        guard let fp = fptr else { return nil }
        var ch:Int
        repeat {
            ch = Int( fgetc(fp) )       // １バイト読み込み
            if ch < 0 { return nil }    // EOFの場合にnilを返す
        }while isalpha(Int32(ch)) == 0
        var s = String(Unicode.Scalar(ch)!)    // １文字だけの文字列
        ch = Int( fgetc(fp) )       // １バイト読み込み
        while isalpha(Int32(ch)) != 0 {        // 英文字の列を作る
            s.append(String(Unicode.Scalar(ch)!))
            ch = Int( fgetc(fp) )   // １バイト読み込み
        }
        return s
    }
}
