func rank<T, U>(key: T, in a: U) -> (Int, Int)
    where T:Comparable, U:Sequence, U.Element == T
{
    var count = 1, total = 1        // 全体の個数にはkeyもカウント
    for elm in a {
        if key > elm { count += 1 } // keyより大きい要素数を数える
        total += 1
    }
    return (count, total)
}

let divg: Set<Double> = [ 0.57, 1.13, -0.27, 3.40 ]
print( rank(key:1, in:divg) )

let str = "アレキサンドライト"
print( rank(key:Character("イ"), in:str) )
