class Alpha {
    var name = "Alpha"
    var value = 0
    init(_ v: Int) { value = v }
}
class Beta : Alpha {
    let sub = "Subclass"
    override init(_ v: Int) { super.init(v); name = "Beta" }
}

func littler(_ x: Alpha, _ y: Alpha) -> Alpha {
    return (x.value < y.value) ? x : y
}

let c = littler(Alpha(100), Beta(5))             // c に Betaのインスタンスが代入
// エラーになる： error: value of type 'Alpha' has no member 'sub'
// print("Littler:", c.name, c.value, c.sub)
print("Littler:", c.name, c.value /*, c.sub */)  // 定数c は Alpha型

// let d = littler(Beta(0), Beta(51))
// プロパティ sub を表示するにはダウンキャストが必要
let d:Beta = littler(Beta(0), Beta(51)) as! Beta
print("Littler:", d.name, d.value, d.sub)

print("------")

func smaller<T: Alpha>(_ x: T, _ y: T) -> T {
    return (x.value < y.value) ? x : y
}
let g = smaller(Alpha(100), Beta(5))             // g に Betaのインスタンスが代入
// エラーになる： error: value of type 'Alpha' has no member 'sub'
// print("Smaller:", g.name, g.value, g.sub)
print("Smaller:", g.name, g.value /*, g.sub */)  // 定数g は Alpha型

let h = smaller(Beta(1), Beta(18))
print("Smaller:", h.name, h.value, h.sub)        // 定数h は Beta型
