struct Labels {
    let names: [String]
    subscript(index: Int) -> String { return names[index - 1] }
    subscript<S>(indices: S) -> [String]
            where S: Sequence, S.Element: BinaryInteger {
        var r = [String]()
        for x in indices where x > 0 { r.append(names[Int(x) - 1]) }
        return r
    }
}

let w = Labels(names:["睦月", "如月", "弥生", "卯月", "皐月", "水無月",
        "文月", "葉月", "長月", "神無月", "霜月", "師走"])

print(w[-2...3])  // ["睦月", "如月", "弥生"] を表示
let smon: [UInt8] = [ 2, 4, 6, 9, 11 ]
print(w[smon])    // ["如月", "卯月", "水無月", "長月", "霜月"] を表示
