let m = ["晴信":68, "香子":52, "あかり":90, "零":75] // データ
let pass = m.flatMap { $0.value >= 60 ? $0.key : nil }
print(pass)  // ["零", "晴信", "あかり"]

enum Reply { // 出席、欠席、同伴者あり
    case attend, notAttend, attendWith(String)
}
let replies:[String:Reply] = ["那由多":.attendWith("伊月"),
    "夢子":.notAttend, "政宗":.attend, "遥":.attendWith("秋穂")]
let attendance:[String] = replies.flatMap {
    (rp:(key: String, value: Reply)) -> [String] in
    switch rp.value {
    case .attend: return [rp.key]                // 本人のみ出席
    case .notAttend: return []                   // 欠席
    case .attendWith(let w): return [rp.key, w]  // 本人と同伴者
    }
}
print(attendance)
// ["那由多", "伊月", "政宗", "遥", "秋穂"]
