import Cocoa // このプログラムは macOS上でのみ動作します。

enum ImgError : Error { case ng }   // エラーを定義しておく
let path = "./xcodeProj03.png"      // 入力ファイル名は簡単のために決め打ち
let url = URL(fileURLWithPath:path, isDirectory: false)  // URLを得る
let newurl = url.deletingPathExtension().appendingPathExtension("jpg")
do {
    let imgdata = try Data(contentsOf: url)    // Dataに読み込む
    guard let imgrep = NSBitmapImageRep(data: imgdata) else {
        throw ImgError.ng           // 画像として認識できなければエラー
    }
    // JPEG変換のオプション。圧縮の程度と、透明色を置き換える色の指定
    typealias PropKey = NSBitmapImageRep.PropertyKey
    let prop: [PropKey:Any] = [ PropKey.compressionFactor: 0.5,
        PropKey.fallbackBackgroundColor: NSColor.white ]
    // 変換の結果はData型で得られる
    guard let dat = imgrep.representation(using:.jpeg, properties: prop)
        else { throw ImgError.ng }
    try dat.write(to: newurl, options: [.atomic])  // 書き出す
    print("Done")
} catch { }
