import Foundation

let t = UnsafeMutablePointer<UInt8>.allocate(capacity:10)
for i in 0 ..< 10 { t[i] = UInt8(i) }    // 0から9までを設定
let raw = UnsafeMutableRawPointer(t)

var d1 = Data(bytesNoCopy: raw, count: 10, deallocator: .none)
// ポインタrawが指す領域をそのままDataのバイト列として使う
for i in 0 ..< 10 { print(d1[i], terminator:" ") }
print()       // 0 1 2 ... 9 を表示
var d2 =  d1
for i in 0 ..< 10 { t[i] = UInt8(10 - i) } // 元の領域に違う値を設定
for i in 0 ..< 10 { print(d1[i], terminator:" ") }
for i in 0 ..< 10 { print(d2[i], terminator:" ") }
print()       // どちらも 10 9 8 ... 1 を表示。共有されている

d2[0] = 99    // ここで d2用の領域が確保される (Copy-On-Write)
for i in 0 ..< 10 { t[i] = UInt8(0) }     // すべて0を設定
for i in 0 ..< 10 { print(d1[i], terminator:" ") }
for i in 0 ..< 10 { print(d2[i], terminator:" ") }
print()       // 0 0 ... 0 99 9 8 7 ... 2 1 と表示される
t.deallocate(capacity:10)    // 解放忘れのないように
