import Foundation

class Creature : NSObject {         // 何らかの生物のクラス
    let name: String
    init(_ s:String) { name = s; super.init() }
    @objc func speak() { print(self.name + ": . . .") }
}
class Human : Creature {            // 人間のクラス。initは継承している
    @objc func speak(to who:Creature) {   // 引数に対してあいさつする
        print(self.name + ": こんにちは、" + who.name + "さん。")
    }
}

let sel: Selector = #selector(Creature.speak)        // セレクタ（引数なし）
let selspeak: Selector = #selector(Human.speak(to:)) // セレクタ（引数あり）
let me = Human("良田")
for obj in [ Human("遊太"), Creature("巨人"), Human("瀬能") ] {
    if obj.responds(to: selspeak) {         // セレクタに反応するなら
        obj.perform(selspeak, with:me)      // セレクタと引数で呼び出す
    }else {
        obj.perform(sel)                    // セレクタだけで呼び出す
    }
}
