import Foundation

class Food : NSObject {
    fileprivate let _name: String
    init(_ s:String) { _name = s; super.init() }
}
class Fruit : Food {
    @objc var name: String { return _name }
    @objc func makeJuice() -> Food { return Juice(_name) }
}
class Juice : Food {
    @objc var name: String { return _name + "ジュース" }
    deinit { print("deinit: " + name) }   // 解放時に名前を表示
}

let pear = Fruit("梨"), peach = Fruit("モモ"), orange = Fruit("みかん")
let selmake = #selector(Fruit.makeJuice)
let selname = #selector(getter:Fruit.name) // プロパティに対するセレクタ
// let selname = #selector(getter:Juice.name)
do {
    let a = pear.makeJuice()
    let b = peach.perform(selmake).takeRetainedValue()
    let c = orange.perform(selmake).takeUnretainedValue()
    for jc in [a, b, c] {
        if let obj = jc.perform(selname)?.takeRetainedValue() {
            print(obj)  // プロパティの値をセレクタを使って取り出す
        }
    }
}
