#import <Foundation/Foundation.h>
#import "BlockReverser.h"
#define LongBytes   64    // これ以上のバイト数には memcpy を使う

@implementation BlockReverser {
    void *buffer;
}
- (nonnull instancetype)initWithWidth:(NSInteger)w
                                bytes:(NSInteger)bytes
{
    if ((self = [super init]) != nil) {
        width = w; blockbytes = bytes;
        buffer = (blockbytes >= LongBytes)
                ? malloc(blockbytes) : NULL;
    }
    return self;
}

- (void)dealloc {
    if (buffer) free(buffer);
}

- (void)reverse:(nonnull uchar *)ptr
{
    uchar *head = ptr;  // 反転させる範囲の最初と最後のブロックを指す。
    uchar *tail = ptr + (width - 1) * blockbytes;
    while (head < tail) {  // bytesはピクセルを構成するバイト数
        uchar *p = head, *q = tail;
        if (buffer) {
            memcpy(buffer, p, blockbytes);
            memcpy(p, q, blockbytes);
            memcpy(q, buffer, blockbytes);
        }else {
            for (int i = 0; i < blockbytes; i++, p++, q++) {
                int t = *p; *p = *q; *q = t;
            }
        }
        head += blockbytes;
        tail -= blockbytes;
    }   // 互いに近づく方向に移動させながらブロックを入れ替える。
}
@end
