#import <Foundation/Foundation.h>
#import "Flipper-Swift.h"
#import "FlipOpt.h"

static void errorExit(const char *msg) {
    fprintf(stderr, "Error: %s\n", msg);    // メッセージを表示して終了
    exit(1);
}

int main(int argc, const char **argv) {
    FlipOpt options = 0;  // オプションを表す列挙型
    NSInteger op = 1;
    while (op < argc && argv[op][0] == '-') {    // １文字目が '-' か？
        switch (argv[op][1]) {
        case 'h': options |= Horizontal; break;  // -h : 水平方向に反転
        case 'v': options |= Vertical; break;    // -v : 垂直方向に反転
        default: errorExit("unknown option");
        }
        op++;
    }
    if (op + 2 > argc)
        errorExit("no input/output");
    NSString *input = [NSString stringWithUTF8String: argv[op]];
    NSString *output = [NSString stringWithUTF8String: argv[op+1]];
    NSData *indat = [NSData dataWithContentsOfFile: input]; // 画像を読む
    if (indat == nil)
        errorExit("illegal input data");
    Flipper *flip = [[Flipper alloc] initWithData:indat];
    [flip flipWithOptions: options];     // SwiftのクラスFlipperを使う
    NSData *outdat = [flip dataForJPEG]; // 出力するデータを得る
    if (outdat == nil)
        errorExit("internal error");
    if (![outdat writeToFile:output atomically:YES])
        errorExit("can't output");
    return 0;
}
